
TYPO3.Flow - Bug # 33882

Status: Rejected Priority: Should have
Author: Kira Backes Category: I18n
Created: 2012-02-13 Assigned To: Karsten Dambekalns
Updated: 2012-02-16 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: Git master
Subject: XliffParser does not allow id-less translation
Description

If I want to translate completely without IDs I’m still forced to add IDs in the translation .xlf, because the id-less translation entries are
overwritten at the following code (line 47 TYPO3.FLOW3/Classes/I18n/Xliff/XliffParser.php):

                $parsedData['translationUnits'][(string)$translationElement['id']][0] = array(
                    'source' => (string)$translationElement->source,
                    'target' => (string)$translationElement->target,
                );

This is fixed by replacing the previous code with the following:

                $translationElementId = (string)$translationElement['id'];
                if ($translationElementId === '') {
                    $translationElementId = uniqid();
                }
                $parsedData['translationUnits'][$translationElementId][0] = array(
                    'source' => (string)$translationElement->source,
                    'target' => (string)$translationElement->target,
                );

History
#1 - 2012-02-13 14:13 - Kira Backes
- Project changed from TYPO3 Flow Base Distribution to TYPO3.Flow

#2 - 2012-02-16 10:48 - Karsten Dambekalns
- Category set to I18n
- Status changed from New to Rejected
- Assigned To set to Karsten Dambekalns
- Has patch set to No

This will never change, as XLIFF requires id attributes to be present. Plus, id-based translation is recommended as it is more reliable and distinctive.

#3 - 2012-02-16 10:57 - Kira Backes

Okay, but then you should throw an exception in case of a missing id attribute?
#4 - 2012-02-16 11:10 - Karsten Dambekalns

Kira Backes wrote:

Okay, but then you should throw an exception in case of a missing id attribute?

Good point, I created #33971 for that.
